#include <16f1947.h>
#device ADC=10
#include <string.h>
#include <stdlib.h>
#fuses INTRC_IO,NOWDT,NOLVP,NOMCLR,PROTECT,NOBROWNOUT
#use delay(CLOCK=32MHz)
#use rs232(baud=19200,xmit=PIN_C6,rcv=PIN_C7,parity=N,bits=8,stream=c1,ERRORS)//
//#use rs232(baud=19200,xmit=PIN_G1,rcv=PIN_G2,parity=N,bits=8,stream=c2,ERRORS)//
//#use i2c(MASTER, SDA=PIN_C4, SCL=PIN_C3,SLOW,FORCE_HW)//FAST=400kbps SLOW=100kbps
//#include "rtc_lib.c"
//#include "eeprom.c"
//#include "am2321.c"//xExZT[
//#include "aqmxx02a.c"//LN^LCDW[
//#include "so1602awxb.c"//L@ELLN^W[
//#include "tc74hc595.c"//o̓WbNIC
#include "ws2822.c"//VAʐMLED WS2822

//ϐ蓖
//VA֌W
int get_command_value_c1 = 0;
int get_command_value_c2 = 0;
char get_command_c1[80] = {
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0};//MR}hɂ킹
char get_command_c2[10] = {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0};
char compare_command_c1[10] = {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0};
char compare_command_c2[10] = {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0};
char punctuate[] = ",";//VA̋̕؂
//tbJ[֌W
int flicker_hi = 0;
int flicker_hi_one = 0;
int flicker_middle = 0;
int flicker_middle_one = 0;
int flicker_low = 0;
int flicker_low_one = 0;
int ws2822_process_one = 0;
long ws2822_process_count = 0;
long counttimer1 = 0;
long counttimer2 = 0;
long counttimer3 = 0;
//AiOv֌W
long analog_value = 0;
//fW^͊֌W
int port1_ra1 = 0;

//̑
int mode = 2;//1:address set. 2:color data out.

//֐錾
void startup();
void serial_process1();
void serial_process2();
void output_process();
void input_process();

//VÅ荞
#int_rda
void isr_rcv(){
	while(kbhit(c1)){  // }CR̎Mobt@̃f[^SĎM
		get_command_c1[get_command_value_c1] = fgetc(c1);//Mf[^o
		fprintf(c1,"%c",get_command_c1[get_command_value_c1]);
		get_command_value_c1++;//CfbNX{P
	}
}

#int_timer0
void int_timer(){
	//160usec

	//ŏJEg̃^C~O͉ĽvZƂȂB
	//1^32MHz0.031250sF1pX̎
	//0.031250s~40.125sFł͂4{̎(́~4{)
	//0.125s~256(vXP[)32s

	//̃^C~Ol160sŏꍇA
	//160s/32s = 5ƂȂAݒl
	//255-5+1 = 251
	
	//^C}[lZbg
	set_timer0(251);

	//flicker_hi = !flicker_hi;
/*	
	if(counttimer1 > 613){
		//100msecPʂ̎s
		
		//JE^[Zbg
		counttimer1 = 0;
		
		flicker_hi_one = 1;		
	}
	counttimer1++;
*/

/*
	if(counttimer2 > 1226){
		//200msecPʂ̎s
		
		//JE^[Zbg
		counttimer2 = 0;
		
		flicker_middle = !flicker_middle;
		flicker_middle_one = 1;
	}
	counttimer2++;
*/

/*
	if(counttimer3 > 3065){
		//500msecPʂ̎s
		
		//JE^[Zbg
		counttimer3 = 0;
		
		flicker_low = !flicker_low;
		flicker_low_one = 1;

		//xExv
		//QɂP̊Ōv
		//am2321_read();
	}
	counttimer3++;
*/

//	if(ws2822_process_count >3065){
//		ws2822_process_count = 0;
//	}
//	ws2822_process_count++;

//	ws2822_process_one = 1;
}

//X^[gAbv
void startup(){
	
	//delay_ms(4000);

	//NbNݒ
	setup_oscillator(OSC_8MHZ|OSC_PLL_ON);

	//setup_timer_0(RTCC_INTERNAL | RTCC_DIV_256 );//RTCC_DIV_32
	//enable_interrupts(INT_TIMER0); //^C}荞݋
	enable_interrupts(INT_RDA); //VA荞݋
	enable_interrupts(GLOBAL); //S荞݋

	//AiO|[g̐ݒ
	setup_vref(VREF_ON|VREF_ADC_4v096);
	setup_adc(ADC_CLOCK_INTERNAL);
	setup_adc_ports(sAN0,VSS_FVR);
	//setup_adc_ports(NO_ANALOGS);

	//|[gݒ 0:OUT 1:IN
	set_tris_a(0b00000000);//PORT1
	set_tris_b(0b00000000);
	set_tris_c(0b10011000);
	set_tris_d(0b00000000);//PORT1
	set_tris_e(0b00000000);//PORT2
	set_tris_f(0b00000000);//PORT2
	set_tris_g(0b00000100);

	//d肷̂҂
	delay_ms(200);

	//NbNAEgݒ(1b)
	//rtc_timer_set(0x83,0,0);

	//L@ELLN^W[̏
	//so1602awxb_init();

	//L@ELLN^W[\
	//so1602awxb_puts("abc");
	//printf(so1602awxb_puts,"    %02x:%02x:%02x    ",hour,min,sec);

	//LCD̏
	//RgXĝߎgpdw@3 = 3.3V 5 = 5V
	//delay܂܂Ă̂ŃX^[gAbvȊOŎgpȂ
	//aqmxx02a_init(5) ;

	//aqmxx02a_setcursor(0,0);        // \ʒuݒ肷
	//aqmxx02a_puts(")ްï");
	//aqmxx02a_puts("");
	//aqmxx02a_setcursor(0,1);        // \ʒuݒ肷
	//aqmxx02a_puts(" ZEATEC co.,ltd.");

	//J[ݒ
	Color_R[0] = 0x00;		Color_G[0] = 0x00;		Color_B[0] = 0x00;
	Color_R[1] = 0x00;		Color_G[1] = 0x00;		Color_B[1] = 0x00;
	Color_R[2] = 0xff;		Color_G[2] = 0x00;		Color_B[2] = 0x00;
	Color_R[3] = 0x00;		Color_G[3] = 0x00;		Color_B[3] = 0x00;
	Color_R[4] = 0xff;		Color_G[4] = 0xff;		Color_B[4] = 0x00;
	Color_R[5] = 0x00;		Color_G[5] = 0xff;		Color_B[5] = 0x00;
	Color_R[6] = 0x00;		Color_G[6] = 0x00;		Color_B[6] = 0xff;
	Color_R[7] = 0xff;		Color_G[7] = 0x00;		Color_B[7] = 0xff;
	Color_R[8] = 0x00;		Color_G[8] = 0x00;		Color_B[8] = 0x00;
	Color_R[9] = 0xff;		Color_G[9] = 0xff;		Color_B[9] = 0xff;

	Color_R[10] = 0x00;		Color_G[10] = 0x00;		Color_B[10] = 0x00;
	Color_R[11] = 0x00;		Color_G[11] = 0x00;		Color_B[11] = 0x00;
	Color_R[12] = 0xff;		Color_G[12] = 0x00;		Color_B[12] = 0x00;
	Color_R[13] = 0x00;		Color_G[13] = 0x00;		Color_B[13] = 0x00;
	Color_R[14] = 0x00;		Color_G[14] = 0x00;		Color_B[14] = 0x00;
	Color_R[15] = 0x00;		Color_G[15] = 0xff;		Color_B[15] = 0x00;
	Color_R[16] = 0x00;		Color_G[16] = 0x00;		Color_B[16] = 0xff;
	Color_R[17] = 0x00;		Color_G[17] = 0x00;		Color_B[17] = 0x00;
	Color_R[18] = 0x00;		Color_G[18] = 0x00;		Color_B[18] = 0x00;
	Color_R[19] = 0xff;		Color_G[19] = 0xff;		Color_B[19] = 0xff;

	Color_R[20] = 0x00;		Color_G[20] = 0x00;		Color_B[20] = 0x00;
	Color_R[21] = 0x00;		Color_G[21] = 0x00;		Color_B[21] = 0x00;
	Color_R[22] = 0xff;		Color_G[22] = 0x00;		Color_B[22] = 0x00;
	Color_R[23] = 0x00;		Color_G[23] = 0x00;		Color_B[23] = 0x00;
	Color_R[24] = 0x00;		Color_G[24] = 0x00;		Color_B[24] = 0x00;
	Color_R[25] = 0x00;		Color_G[25] = 0xff;		Color_B[25] = 0x00;
	Color_R[26] = 0x00;		Color_G[26] = 0x00;		Color_B[26] = 0xff;
	Color_R[27] = 0x00;		Color_G[27] = 0x00;		Color_B[27] = 0x00;
	Color_R[28] = 0x00;		Color_G[28] = 0x00;		Color_B[28] = 0x00;
	Color_R[29] = 0xff;		Color_G[29] = 0xff;		Color_B[29] = 0xff;

	Color_R[30] = 0x00;		Color_G[30] = 0x00;		Color_B[30] = 0x00;
	Color_R[31] = 0x00;		Color_G[31] = 0x00;		Color_B[31] = 0x00;
	Color_R[32] = 0xff;		Color_G[32] = 0x00;		Color_B[32] = 0x00;
	Color_R[33] = 0x00;		Color_G[33] = 0x00;		Color_B[33] = 0x00;
	Color_R[34] = 0x00;		Color_G[34] = 0x00;		Color_B[34] = 0x00;
	Color_R[35] = 0x00;		Color_G[35] = 0xff;		Color_B[35] = 0x00;
	Color_R[36] = 0x00;		Color_G[36] = 0x00;		Color_B[36] = 0xff;
	Color_R[37] = 0x00;		Color_G[37] = 0x00;		Color_B[37] = 0x00;
	Color_R[38] = 0x00;		Color_G[38] = 0x00;		Color_B[38] = 0x00;
	Color_R[39] = 0xff;		Color_G[39] = 0xff;		Color_B[39] = 0xff;

	Color_R[40] = 0x00;		Color_G[40] = 0x00;		Color_B[40] = 0x00;
	Color_R[41] = 0x00;		Color_G[41] = 0x00;		Color_B[41] = 0x00;
	Color_R[42] = 0xff;		Color_G[42] = 0x00;		Color_B[42] = 0x00;
	Color_R[43] = 0x00;		Color_G[43] = 0x00;		Color_B[43] = 0x00;
	Color_R[44] = 0x00;		Color_G[44] = 0x00;		Color_B[44] = 0x00;
	Color_R[45] = 0x00;		Color_G[45] = 0xff;		Color_B[45] = 0x00;
	Color_R[46] = 0x00;		Color_G[46] = 0x00;		Color_B[46] = 0xff;
	Color_R[47] = 0x00;		Color_G[47] = 0x00;		Color_B[47] = 0x00;
	Color_R[48] = 0x00;		Color_G[48] = 0x00;		Color_B[48] = 0x00;
	Color_R[49] = 0xff;		Color_G[49] = 0xff;		Color_B[49] = 0xff;

	Color_R[50] = 0x00;		Color_G[50] = 0x00;		Color_B[50] = 0x00;
	Color_R[51] = 0x00;		Color_G[51] = 0x00;		Color_B[51] = 0x00;
	Color_R[52] = 0xff;		Color_G[52] = 0x00;		Color_B[52] = 0x00;
	Color_R[53] = 0x00;		Color_G[53] = 0x00;		Color_B[53] = 0x00;
	Color_R[54] = 0x00;		Color_G[54] = 0x00;		Color_B[54] = 0x00;
	Color_R[55] = 0x00;		Color_G[55] = 0xff;		Color_B[55] = 0x00;
	Color_R[56] = 0x00;		Color_G[56] = 0x00;		Color_B[56] = 0xff;
	Color_R[57] = 0xff;		Color_G[57] = 0x00;		Color_B[57] = 0xff;
	Color_R[58] = 0x00;		Color_G[58] = 0x00;		Color_B[58] = 0x00;
	Color_R[59] = 0xff;		Color_G[59] = 0xff;		Color_B[59] = 0xff;

/*
	//AhXݒsHIƂĂ
	output_bit(PIN_ADDRESS,1);
	//J[ݒsHIƂĂ
	output_bit(PIN_COLORDATA,1);
*/

}

//C
void main(){
	
	int tmp1 = 0;
	int tmp_color_r = 0;
	int tmp_color_g = 0;
	int tmp_color_b = 0;

	//X^[gAbv
	startup();

	while(true){

/*
		//͏
		input_process();

		//VA|[g̃R}h
		serial_process1();
		//serial_process2();

*/
		if(mode == 1){
			
			//AhX
			//6mSecȏŏALED̐ɈˑB
			ws2822_set_address(1);

			//mode = 2;
		}else if(mode == 2){

/*
			tmp_color_r = Color_R[ws2822_led_value-1];
			tmp_color_g = Color_G[ws2822_led_value-1];
			tmp_color_b = Color_B[ws2822_led_value-1];
			for(tmp1=0;tmp1<ws2822_led_value-1;tmp1++){
				Color_R[ws2822_led_value-1-tmp1] = Color_R[ws2822_led_value-2-tmp1];
				Color_G[ws2822_led_value-1-tmp1] = Color_G[ws2822_led_value-2-tmp1];
				Color_B[ws2822_led_value-1-tmp1] = Color_B[ws2822_led_value-2-tmp1];
			}
			Color_R[0] = tmp_color_r;
			Color_G[0] = tmp_color_g;
			Color_B[0] = tmp_color_b;
*/

			//J[Zbg
			//LED18030fpsŏƂA3pPbg132uSecȏƂȂB
			ws2822_set_color();	
		}

		//flicker_hi = !flicker_hi;

		//o͏
		output_process();	
	}
}

//̓|[g擾
void input_process(){
	//if(input(PIN_A1)==1){
	//	//ON̎
	//	port1_ra1 = 1;
	//}else{
	//	//OFF̎
	//	port1_ra1 = 0;
	//}
}

//o̓|[g
void output_process(){

	//LED\(8)
	//LEDo͔͂]邱
	output_bit(PIN_B0,!flicker_hi);
	output_bit(PIN_B1,!flicker_low);
	output_bit(PIN_B2,!flicker_hi);
	output_bit(PIN_B3,!flicker_low);
	output_bit(PIN_B4,!flicker_hi);
	output_bit(PIN_B5,!flicker_low);
	output_bit(PIN_C0,!flicker_hi);
	output_bit(PIN_C1,!flicker_low);

	//LED\(5)
	//LEDo͔͂]邱
	output_bit(PIN_C2,!flicker_hi);
	output_bit(PIN_C5,!flicker_low);
	output_bit(PIN_G0,!flicker_hi);
	output_bit(PIN_G3,!flicker_low);
	output_bit(PIN_G4,!flicker_hi);



	//PORT1
	//output_bit(PIN_A0,!flicker_hi);
	//output_bit(PIN_A1,!flicker_hi);
	output_bit(PIN_A2,!flicker_hi);
	//output_bit(PIN_A3,!flicker_hi);
	output_bit(PIN_A4,!flicker_hi);
	output_bit(PIN_A5,!flicker_hi);
	output_bit(PIN_A6,!flicker_hi);
	output_bit(PIN_A7,!flicker_hi);

/*
	if(flicker_hi==0){
		//PORT1
		output_d(0xff);
		//PORT2
		//output_e(0xff);
		output_f(0xff);
	}else{
		//PORT1
		output_d(0x00);
		//PORT2
		//output_e(0x00);
		output_f(0x00);
	}
*/

}

//VA|[g̃R}h
void serial_process1(){
	int tmp1 = 0;
	char *command;
	int *param1;
	//char *param1;
	int rdata = 0;

	if(get_command_c1[get_command_value_c1-1]==0xd){
		//R}hƃp[^𕪊
		command = strtok(get_command_c1,punctuate);
		//param1 = atoi(strtok(null,punctuate));
		param1 = strtok(null,punctuate);

		fprintf(c1,"\r\n");

		strcpy(compare_command_c1,"?\r");
		if(strcmp(command,compare_command_c1)==0){
			//wv
			fprintf(c1,"ZT-****-SOFT Ver.0.90\r\n");
			//rtc_date_read();			
			//fprintf(c1,"%02x/%02x/%02x %02x:%02x:%02x\r\n",year,month,day,hour,min,sec);
			fprintf(c1,"analog_value=%ldmV\r\n",analog_value);
			fprintf(c1,"port1_ra1=%d\r\n",port1_ra1);
			
			//AhXԍPɃf[^
			//eeprom_write(0xa0,0x0001,0x05);
			//AhXԍPf[^ǂݍ
			//rdata = eeprom_read(0xa0, 0x0001);
			//fprintf(c1,"rdata=%x\r\n",rdata);

			//AhXԍPɃf[^
			//eeprom_write(0xa4,0x000a,0x05);
			//AhXԍPf[^ǂݍ
			//rdata = eeprom_read(0xa4, 0x000a);
			fprintf(c1,"1rdata=%x\r\n",rdata);
		}

		//strcpy(compare_command_c1,"p");
		//if(strcmp(command,compare_command_c1)==0){
		//	//p[^̎擾
		//	//up,1v1param1ɓ
		//	fprintf(c1,"param1_u=%u ok.\r\n",param1);
		//}

		strcpy(compare_command_c1,"mode");
		if(strcmp(command,compare_command_c1)==0){
			//[hݒ
			
			if(strlen(param1) == 2){
				//p[^𕪊
				mode = (param1[0] - 0x30);

				fprintf(c1,"mode set ok.\r\n");
				if(mode == 2){
					fprintf(c1,"Led power reset.\r\n");
				}
			}else{
				fprintf(c1,"Parameter error.\r\n");
			}
		}

		strcpy(compare_command_c1,"mode\r");
		if(strcmp(command,compare_command_c1)==0){
			//ݎ\
			fprintf(c1,"mode = %01x\r\n",mode);
		}

		//strcpy(compare_command_c1,"time");
		//if(strcmp(command,compare_command_c1)==0){
		//	//Ԃݒ
		//	//ݒFtime,101006101840(2010N1006101840b)
		//	
		//	if(strlen(param1) == 13){
		//		//p[^𕪊
		//		year = ((param1[0] - 0x30)*16) + (param1[1] - 0x30);
		//		month = ((param1[2] - 0x30)*16) + (param1[3] - 0x30);
		//		day = ((param1[4] - 0x30)*16) + (param1[5] - 0x30);
		//		hour = ((param1[6] - 0x30)*16) + (param1[7] - 0x30);
		//		min = ((param1[8] - 0x30)*16) + (param1[9] - 0x30);
		//		sec = ((param1[10] - 0x30)*16) + (param1[11] - 0x30);

		//		rtc_date_set();
		//		fprintf(c1,"time set ok.\r\n");
		//	}else{
		//		fprintf(c1,"Parameter error.\r\n");
		//	}

		//}

		//strcpy(compare_command_c1,"time\r");
		//if(strcmp(command,compare_command_c1)==0){
		//	//ݎ\
		//	rtc_date_read();			
		//	fprintf(c1,"%02x/%02x/%02x %02x:%02x:%02x\r\n",year,month,day,hour,min,sec);
		//}

		//strcpy(compare_command_c1,"temp\r");
		//if(strcmp(command,compare_command_c1)==0){

		//	//xEx\
		//	fprintf(c1,"temperature = %ld.%ldC\r\n",(temperature-(temperature%10))/10,temperature%10);
		//	fprintf(c1,"humidity = %ld.%ld%%\r\n",(humidity-(humidity%10))/10,humidity%10);
		//}

		//SăNA
		for(tmp1=0;tmp1<80;++tmp1){
			get_command_c1[tmp1] = 0x0;
		}
		get_command_value_c1 = 0;

		//QƗp̃R}hNA
		for(tmp1=0;tmp1<10;++tmp1){
			compare_command_c1[tmp1] = 0x0;
		}
	}
}

//void serial_process2(){
//	int tmp1 = 0;
//	char *command;
//	int *param1;
//	//char *param1;
//
//	while(kbhit(c2)){  // }CR̎Mobt@̃f[^SĎM
//		get_command_c2[get_command_value_c2] = fgetc(c2);//Mf[^o
//		fprintf(c2,"%c",get_command_c2[get_command_value_c2]);
//		get_command_value_c2++;
//	}
//
//	if(get_command_c2[get_command_value_c2-1]==0xd){
//		//R}hƃp[^𕪊
//		command = strtok(get_command_c2,punctuate);
//		//param1 = atoi(strtok(null,punctuate));
//		param1 = strtok(null,punctuate);
//
//		fprintf(c2,"\r\n");
//
//		strcpy(compare_command_c2,"?\r");
//		if(strcmp(command,compare_command_c2)==0){
//			//wv
//			fprintf(c2,"ZT-****-SOFT Ver.0.90\r\n");
//			rtc_date_read();			
//			fprintf(c2,"%02x/%02x/%02x %02x:%02x:%02x\r\n",year,month,day,hour,min,sec);
//		}
//
//		strcpy(compare_command_c2,"time");
//		if(strcmp(command,compare_command_c2)==0){
//			//Ԃݒ
//			//ݒFtime,101006101840(2010N1006101840b)
//			
//			if(strlen(param1) == 13){
//				//p[^𕪊
//				year = ((param1[0] - 0x30)*16) + (param1[1] - 0x30);
//				month = ((param1[2] - 0x30)*16) + (param1[3] - 0x30);
//				day = ((param1[4] - 0x30)*16) + (param1[5] - 0x30);
//				hour = ((param1[6] - 0x30)*16) + (param1[7] - 0x30);
//				min = ((param1[8] - 0x30)*16) + (param1[9] - 0x30);
//				sec = ((param1[10] - 0x30)*16) + (param1[11] - 0x30);
//
//				rtc_date_set();
//				fprintf(c2,"time set ok.\r\n");
//			}else{
//				fprintf(c2,"Parameter error.\r\n");
//			}
//
//		}
//
//		strcpy(compare_command_c2,"time\r");
//		if(strcmp(command,compare_command_c2)==0){
//			//ݎ\
//			rtc_date_read();			
//			fprintf(c2,"%02x/%02x/%02x %02x:%02x:%02x\r\n",year,month,day,hour,min,sec);
//		}
//
//		//SăNA
//		for(tmp1=0;tmp1<10;++tmp1){
//			get_command_c2[tmp1] = 0x0;
//		}
//		get_command_value_c2 = 0;
//
//		//QƗp̃R}hNA
//		for(tmp1=0;tmp1<10;++tmp1){
//			compare_command_c2[tmp1] = 0x0;
//		}
//	}
//}


