#include <16f1947.h>
#device ADC=10
#include <string.h>
#include <stdlib.h>
#fuses INTRC_IO,NOWDT,NOLVP,NOMCLR,PROTECT,NOBROWNOUT
#use delay(CLOCK=32MHz)
#use rs232(baud=19200,xmit=PIN_C6,rcv=PIN_C7,parity=N,bits=8,stream=c1,ERRORS)//
//#use i2c(MASTER, SDA=PIN_C4, SCL=PIN_C3,SLOW,FORCE_HW)//FAST=400kbps SLOW=100kbps
//#include "rtc_lib.c"
//#include "eeprom.c"
//#include "am2321.c"//xExZT[
//#include "aqmxx02a.c"//LN^LCDW[
//#include "so1602awxb.c"//L@ELLN^W[
//#include "tc74hc595.c"//o̓WbNIC
#include "ws2822.c"//VAʐMLED WS2822

//ϐ蓖
//VA֌W
int get_command_value_c1 = 0;
int get_command_value_c2 = 0;
char get_command_c1[80] = {
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0};//MR}hɂ킹
char get_command_c2[10] = {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0};
char compare_command_c1[10] = {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0};
char compare_command_c2[10] = {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0};
char punctuate[] = ",";//VA̋̕؂
//tbJ[֌W
int flicker_hi = 0;
int flicker_hi_one = 0;
int flicker_middle = 0;
int flicker_middle_one = 0;
int flicker_low = 0;
int flicker_low_one = 0;
int ws2822_process_one = 0;
long ws2822_process_count = 0;
long counttimer1 = 0;
long counttimer2 = 0;
long counttimer3 = 0;
//AiOv֌W
long analog_value = 0;
//fW^͊֌W
int port1_ra0 = 0;
int port1_ra0_re = 1;
int port1_ra1 = 0;
int port1_ra1_re = 1;
int port1_ra2 = 0;
int port1_ra2_re = 1;
int port1_ra3 = 0;
int port1_ra3_re = 1;
int btn_0 = 0;
int btn_1 = 0;
int btn_2 = 0;
int btn_3 = 0;

//̑
int mode = 2;//1:address set. 2:color data out.
int step = 0;

//֐錾
void startup();
void serial_process1();
void serial_process2();
void output_process();
void input_process();

//X^[gAbv
void startup(){
	
	//delay_ms(4000);

	//NbNݒ
	setup_oscillator(OSC_8MHZ|OSC_PLL_ON);

	//setup_timer_0(RTCC_INTERNAL | RTCC_DIV_256 );//RTCC_DIV_32
	//enable_interrupts(INT_TIMER0); //^C}荞݋
	//enable_interrupts(INT_RDA); //VA荞݋
	//enable_interrupts(GLOBAL); //S荞݋

	//AiO|[g̐ݒ
	setup_vref(VREF_ON|VREF_ADC_4v096);
	setup_adc(ADC_CLOCK_INTERNAL);
	//setup_adc_ports(sAN0,VSS_FVR);
	//setup_adc_ports(NO_ANALOGS);

	//|[gݒ 0:OUT 1:IN
	set_tris_a(0b00001111);//PORT1
	set_tris_b(0b00000000);
	set_tris_c(0b10011000);
	set_tris_d(0b00000000);//PORT1
	set_tris_e(0b00000000);//PORT2
	set_tris_f(0b00000000);//PORT2
	set_tris_g(0b00000000);

	//d肷̂҂
	delay_ms(200);


	//J[ݒ
	Color_R[1] = 0x00;		Color_G[1] = 0x00;		Color_B[1] = 0x00;
	Color_R[2] = 0x00;		Color_G[2] = 0x00;		Color_B[2] = 0x00;
	Color_R[3] = 0x00;		Color_G[3] = 0x00;		Color_B[3] = 0x00;
	Color_R[4] = 0x00;		Color_G[4] = 0x00;		Color_B[4] = 0x00;
	Color_R[5] = 0x00;		Color_G[5] = 0x00;		Color_B[5] = 0x00;
	Color_R[6] = 0x00;		Color_G[6] = 0x00;		Color_B[6] = 0x00;
	Color_R[7] = 0x00;		Color_G[7] = 0x00;		Color_B[7] = 0x00;
	Color_R[8] = 0x00;		Color_G[8] = 0x00;		Color_B[8] = 0x00;
	Color_R[9] = 0x00;		Color_G[9] = 0x00;		Color_B[9] = 0x00;
	Color_R[10] = 0x00;		Color_G[10] = 0x00;		Color_B[10] = 0x00;

	Color_R[11] = 0x00;		Color_G[11] = 0x00;		Color_B[11] = 0x00;
	Color_R[12] = 0x00;		Color_G[12] = 0x00;		Color_B[12] = 0x00;
	Color_R[13] = 0x00;		Color_G[13] = 0x00;		Color_B[13] = 0x00;
	Color_R[14] = 0x00;		Color_G[14] = 0x00;		Color_B[14] = 0x00;
	Color_R[15] = 0x00;		Color_G[15] = 0x00;		Color_B[15] = 0x00;
	Color_R[16] = 0x00;		Color_G[16] = 0x00;		Color_B[16] = 0x00;
	Color_R[17] = 0x00;		Color_G[17] = 0x00;		Color_B[17] = 0x00;
	Color_R[18] = 0x00;		Color_G[18] = 0x00;		Color_B[18] = 0x00;
	Color_R[19] = 0x00;		Color_G[19] = 0x00;		Color_B[19] = 0x00;
	Color_R[20] = 0x00;		Color_G[20] = 0x00;		Color_B[20] = 0x00;

	Color_R[21] = 0x00;		Color_G[21] = 0x00;		Color_B[21] = 0x00;
	Color_R[22] = 0x00;		Color_G[22] = 0x00;		Color_B[22] = 0x00;
	Color_R[23] = 0x00;		Color_G[23] = 0x00;		Color_B[23] = 0x00;
	Color_R[24] = 0x00;		Color_G[24] = 0x00;		Color_B[24] = 0x00;
	Color_R[25] = 0x00;		Color_G[25] = 0x00;		Color_B[25] = 0x00;
	Color_R[26] = 0x00;		Color_G[26] = 0x00;		Color_B[26] = 0x00;
	Color_R[27] = 0x00;		Color_G[27] = 0x00;		Color_B[27] = 0x00;
	Color_R[28] = 0x00;		Color_G[28] = 0x00;		Color_B[28] = 0x00;
	Color_R[29] = 0x00;		Color_G[29] = 0x00;		Color_B[29] = 0x00;
	Color_R[30] = 0x00;		Color_G[30] = 0x00;		Color_B[30] = 0x00;

	Color_R[31] = 0x00;		Color_G[31] = 0x00;		Color_B[31] = 0x00;
	Color_R[32] = 0x00;		Color_G[32] = 0x00;		Color_B[32] = 0x00;
	Color_R[33] = 0x00;		Color_G[33] = 0x00;		Color_B[33] = 0x00;
	Color_R[34] = 0x00;		Color_G[34] = 0x00;		Color_B[34] = 0x00;
	Color_R[35] = 0x00;		Color_G[35] = 0x00;		Color_B[35] = 0x00;
	Color_R[36] = 0x00;		Color_G[36] = 0x00;		Color_B[36] = 0x00;
	Color_R[37] = 0x00;		Color_G[37] = 0x00;		Color_B[37] = 0x00;
	Color_R[38] = 0x00;		Color_G[38] = 0x00;		Color_B[38] = 0x00;
	Color_R[39] = 0x00;		Color_G[39] = 0x00;		Color_B[39] = 0x00;
	Color_R[40] = 0x00;		Color_G[40] = 0x00;		Color_B[40] = 0x00;

	Color_R[41] = 0x00;		Color_G[41] = 0x00;		Color_B[41] = 0x00;
	Color_R[42] = 0x00;		Color_G[42] = 0x00;		Color_B[42] = 0x00;
	Color_R[43] = 0x00;		Color_G[43] = 0x00;		Color_B[43] = 0x00;
	Color_R[44] = 0x00;		Color_G[44] = 0x00;		Color_B[44] = 0x00;
	Color_R[45] = 0x00;		Color_G[45] = 0x00;		Color_B[45] = 0x00;
	Color_R[46] = 0x00;		Color_G[46] = 0x00;		Color_B[46] = 0x00;
	Color_R[47] = 0x00;		Color_G[47] = 0x00;		Color_B[47] = 0x00;
	Color_R[48] = 0x00;		Color_G[48] = 0x00;		Color_B[48] = 0x00;
	Color_R[49] = 0x00;		Color_G[49] = 0x00;		Color_B[49] = 0x00;
	Color_R[50] = 0x00;		Color_G[50] = 0x00;		Color_B[50] = 0x00;

	Color_R[51] = 0x00;		Color_G[51] = 0x00;		Color_B[51] = 0x00;
	Color_R[52] = 0x00;		Color_G[52] = 0x00;		Color_B[52] = 0x00;
	Color_R[53] = 0x00;		Color_G[53] = 0x00;		Color_B[53] = 0x00;
	Color_R[54] = 0x00;		Color_G[54] = 0x00;		Color_B[54] = 0x00;
	Color_R[55] = 0x00;		Color_G[55] = 0x00;		Color_B[55] = 0x00;
	Color_R[56] = 0x00;		Color_G[56] = 0x00;		Color_B[56] = 0x00;
	Color_R[57] = 0x00;		Color_G[57] = 0x00;		Color_B[57] = 0x00;
	Color_R[58] = 0x00;		Color_G[58] = 0x00;		Color_B[58] = 0x00;
	Color_R[59] = 0x00;		Color_G[59] = 0x00;		Color_B[59] = 0x00;
	Color_R[60] = 0x00;		Color_G[60] = 0x00;		Color_B[60] = 0x00;

	Color_R[61] = 0x00;		Color_G[61] = 0x00;		Color_B[61] = 0x00;
	Color_R[62] = 0x00;		Color_G[62] = 0x00;		Color_B[62] = 0x00;
	Color_R[63] = 0x00;		Color_G[63] = 0x00;		Color_B[63] = 0x00;
	Color_R[64] = 0x00;		Color_G[64] = 0x00;		Color_B[64] = 0x00;
	Color_R[65] = 0x00;		Color_G[65] = 0x00;		Color_B[65] = 0x00;
	Color_R[66] = 0x00;		Color_G[66] = 0x00;		Color_B[66] = 0x00;
	Color_R[67] = 0x00;		Color_G[67] = 0x00;		Color_B[67] = 0x00;
	Color_R[68] = 0x00;		Color_G[68] = 0x00;		Color_B[68] = 0x00;
	Color_R[69] = 0x00;		Color_G[69] = 0x00;		Color_B[69] = 0x00;
	Color_R[70] = 0x00;		Color_G[70] = 0x00;		Color_B[70] = 0x00;

	Color_R[71] = 0x00;		Color_G[71] = 0x00;		Color_B[71] = 0x00;
	Color_R[72] = 0x00;		Color_G[72] = 0x00;		Color_B[72] = 0x00;
	Color_R[73] = 0x00;		Color_G[73] = 0x00;		Color_B[73] = 0x00;
	Color_R[74] = 0x00;		Color_G[74] = 0x00;		Color_B[74] = 0x00;
	Color_R[75] = 0x00;		Color_G[75] = 0x00;		Color_B[75] = 0x00;
	Color_R[76] = 0x00;		Color_G[76] = 0x00;		Color_B[76] = 0x00;
	Color_R[77] = 0x00;		Color_G[77] = 0x00;		Color_B[77] = 0x00;
	Color_R[78] = 0x00;		Color_G[78] = 0x00;		Color_B[78] = 0x00;
	Color_R[79] = 0x00;		Color_G[79] = 0x00;		Color_B[79] = 0x00;
	Color_R[80] = 0x00;		Color_G[80] = 0x00;		Color_B[80] = 0x00;

	Color_R[81] = 0x00;		Color_G[81] = 0x00;		Color_B[81] = 0x00;
	Color_R[82] = 0x00;		Color_G[82] = 0x00;		Color_B[82] = 0x00;
	Color_R[83] = 0x00;		Color_G[83] = 0x00;		Color_B[83] = 0x00;
	Color_R[84] = 0x00;		Color_G[84] = 0x00;		Color_B[84] = 0x00;
	Color_R[85] = 0x00;		Color_G[85] = 0x00;		Color_B[85] = 0x00;

	//AhX݃[hǂ𔻒
	if(input(PIN_A0)==1){
		mode = 2;
	}else{
		mode = 1;
	}
}

//C
void main(){
	
	int tmp1 = 0;
	int tmp_color_r = 0;
	int tmp_color_g = 0;
	int tmp_color_b = 0;

	//X^[gAbv
	startup();

	while(true){

		//̓|[g̏
		input_process();

		//VA|[g̃R}h
		serial_process1();

		//{^

		if(btn_0 != 0){	btn_0 = 0;
			if(mode == 6){
				mode = 2;
			}else{
				mode = 6;

				Color_R[1] = 0xff;		Color_G[1] = 0x00;		Color_B[1] = 0x00;
				Color_R[2] = 0xff;		Color_G[2] = 0x00;		Color_B[2] = 0x00;
				Color_R[3] = 0xff;		Color_G[3] = 0x00;		Color_B[3] = 0x00;
				Color_R[4] = 0xff;		Color_G[4] = 0x00;		Color_B[4] = 0x00;
				Color_R[5] = 0xff;		Color_G[5] = 0x00;		Color_B[5] = 0x00;
				Color_R[6] = 0xff;		Color_G[6] = 0x00;		Color_B[6] = 0x00;
				Color_R[7] = 0xff;		Color_G[7] = 0x00;		Color_B[7] = 0x00;
				Color_R[8] = 0xff;		Color_G[8] = 0x00;		Color_B[8] = 0x00;
				Color_R[9] = 0xff;		Color_G[9] = 0x00;		Color_B[9] = 0x00;
				Color_R[10] = 0xff;		Color_G[10] = 0x00;		Color_B[10] = 0x00;

				Color_R[11] = 0xff;		Color_G[11] = 0x00;		Color_B[11] = 0x00;
				Color_R[12] = 0xff;		Color_G[12] = 0x00;		Color_B[12] = 0x00;
				Color_R[13] = 0xff;		Color_G[13] = 0x00;		Color_B[13] = 0x00;
				Color_R[14] = 0xff;		Color_G[14] = 0x00;		Color_B[14] = 0x00;
				Color_R[15] = 0xff;		Color_G[15] = 0x00;		Color_B[15] = 0x00;
				Color_R[16] = 0xff;		Color_G[16] = 0x00;		Color_B[16] = 0x00;
				Color_R[17] = 0xff;		Color_G[17] = 0x00;		Color_B[17] = 0x00;
				Color_R[18] = 0xff;		Color_G[18] = 0x00;		Color_B[18] = 0x00;
				Color_R[19] = 0xff;		Color_G[19] = 0x00;		Color_B[19] = 0x00;
				Color_R[20] = 0xff;		Color_G[20] = 0x00;		Color_B[20] = 0x00;
			}
		}

		if(btn_1 != 0){	btn_1 = 0;
			if(mode == 3){
				mode = 2;
			}else{
				mode = 3;

				//EBJ[[h
				ws2822_step_weight = 20;

				Color_R[1] = 0x00;		Color_G[1] = 0x00;		Color_B[1] = 0x00;
				Color_R[2] = 0x00;		Color_G[2] = 0x00;		Color_B[2] = 0x00;
				Color_R[3] = 0x00;		Color_G[3] = 0x00;		Color_B[3] = 0x00;
				Color_R[4] = 0x00;		Color_G[4] = 0x00;		Color_B[4] = 0x00;
				Color_R[5] = 0x00;		Color_G[5] = 0x00;		Color_B[5] = 0x00;
				Color_R[6] = 0x00;		Color_G[6] = 0x00;		Color_B[6] = 0x00;
				Color_R[7] = 0x00;		Color_G[7] = 0x00;		Color_B[7] = 0x00;
				Color_R[8] = 0x00;		Color_G[8] = 0x00;		Color_B[8] = 0x00;
				Color_R[9] = 0x00;		Color_G[9] = 0x00;		Color_B[9] = 0x00;
				Color_R[10] = 0x00;		Color_G[10] = 0x00;		Color_B[10] = 0x00;

				Color_R[11] = 0xff;		Color_G[11] = 0xa5;		Color_B[11] = 0x00;
				Color_R[12] = 0xff;		Color_G[12] = 0xa5;		Color_B[12] = 0x00;
				Color_R[13] = 0xff;		Color_G[13] = 0xa5;		Color_B[13] = 0x00;
				Color_R[14] = 0xff;		Color_G[14] = 0xa5;		Color_B[14] = 0x00;
				Color_R[15] = 0xff;		Color_G[15] = 0xff;		Color_B[15] = 0xff;
				Color_R[16] = 0x00;		Color_G[16] = 0x00;		Color_B[16] = 0x00;
				Color_R[17] = 0x00;		Color_G[17] = 0x00;		Color_B[17] = 0x00;
				Color_R[18] = 0x00;		Color_G[18] = 0x00;		Color_B[18] = 0x00;
				Color_R[19] = 0x00;		Color_G[19] = 0x00;		Color_B[19] = 0x00;
				Color_R[20] = 0x00;		Color_G[20] = 0x00;		Color_B[20] = 0x00;
			}
		}

		if(btn_2 != 0){	btn_2 = 0;
			if(mode == 4){
				mode = 2;
			}else{
				mode = 4;

				//EEBJ[[h
				ws2822_step_weight = 20;

				Color_R[1] = 0x00;		Color_G[1] = 0x00;		Color_B[1] = 0x00;
				Color_R[2] = 0x00;		Color_G[2] = 0x00;		Color_B[2] = 0x00;
				Color_R[3] = 0x00;		Color_G[3] = 0x00;		Color_B[3] = 0x00;
				Color_R[4] = 0x00;		Color_G[4] = 0x00;		Color_B[4] = 0x00;
				Color_R[5] = 0x00;		Color_G[5] = 0x00;		Color_B[5] = 0x00;
				Color_R[6] = 0xff;		Color_G[6] = 0xff;		Color_B[6] = 0xff;
				Color_R[7] = 0xff;		Color_G[7] = 0xa5;		Color_B[7] = 0x00;
				Color_R[8] = 0xff;		Color_G[8] = 0xa5;		Color_B[8] = 0x00;
				Color_R[9] = 0xff;		Color_G[9] = 0xa5;		Color_B[9] = 0x00;
				Color_R[10] = 0xff;		Color_G[10] = 0xa5;		Color_B[10] = 0x00;

				Color_R[11] = 0x00;		Color_G[11] = 0x00;		Color_B[11] = 0x00;
				Color_R[12] = 0x00;		Color_G[12] = 0x00;		Color_B[12] = 0x00;
				Color_R[13] = 0x00;		Color_G[13] = 0x00;		Color_B[13] = 0x00;
				Color_R[14] = 0x00;		Color_G[14] = 0x00;		Color_B[14] = 0x00;
				Color_R[15] = 0x00;		Color_G[15] = 0x00;		Color_B[15] = 0x00;
				Color_R[16] = 0x00;		Color_G[16] = 0x00;		Color_B[16] = 0x00;
				Color_R[17] = 0x00;		Color_G[17] = 0x00;		Color_B[17] = 0x00;
				Color_R[18] = 0x00;		Color_G[18] = 0x00;		Color_B[18] = 0x00;
				Color_R[19] = 0x00;		Color_G[19] = 0x00;		Color_B[19] = 0x00;
				Color_R[20] = 0x00;		Color_G[20] = 0x00;		Color_B[20] = 0x00;
			}
		}

		if(btn_3 != 0){	btn_3 = 0;
			if(mode == 5){
				mode = 2;
			}else{
				mode = 5;

				//nU[h[h
				ws2822_step_weight = 50;

				Color_R[1] = 0x00;		Color_G[1] = 0x00;		Color_B[1] = 0x00;
				Color_R[2] = 0x00;		Color_G[2] = 0x00;		Color_B[2] = 0x00;
				Color_R[3] = 0x00;		Color_G[3] = 0x00;		Color_B[3] = 0x00;
				Color_R[4] = 0x00;		Color_G[4] = 0x00;		Color_B[4] = 0x00;
				Color_R[5] = 0x00;		Color_G[5] = 0x00;		Color_B[5] = 0x00;
				Color_R[6] = 0xff;		Color_G[6] = 0xff;		Color_B[6] = 0xff;
				Color_R[7] = 0xff;		Color_G[7] = 0xa5;		Color_B[7] = 0x00;
				Color_R[8] = 0xff;		Color_G[8] = 0xa5;		Color_B[8] = 0x00;
				Color_R[9] = 0xff;		Color_G[9] = 0xa5;		Color_B[9] = 0x00;
				Color_R[10] = 0xff;		Color_G[10] = 0xa5;		Color_B[10] = 0x00;

				Color_R[11] = 0xff;		Color_G[11] = 0xa5;		Color_B[11] = 0x00;
				Color_R[12] = 0xff;		Color_G[12] = 0xa5;		Color_B[12] = 0x00;
				Color_R[13] = 0xff;		Color_G[13] = 0xa5;		Color_B[13] = 0x00;
				Color_R[14] = 0xff;		Color_G[14] = 0xa5;		Color_B[14] = 0x00;
				Color_R[15] = 0xff;		Color_G[15] = 0xff;		Color_B[15] = 0xff;
				Color_R[16] = 0x00;		Color_G[16] = 0x00;		Color_B[16] = 0x00;
				Color_R[17] = 0x00;		Color_G[17] = 0x00;		Color_B[17] = 0x00;
				Color_R[18] = 0x00;		Color_G[18] = 0x00;		Color_B[18] = 0x00;
				Color_R[19] = 0x00;		Color_G[19] = 0x00;		Color_B[19] = 0x00;
				Color_R[20] = 0x00;		Color_G[20] = 0x00;		Color_B[20] = 0x00;
			}
		}



		if(mode == 1){
		
			//AhX
			ws2822_set_address();
		}else if(mode == 2){
			//ҋ@

			Color_R[1] = 0x00;		Color_G[1] = 0x00;		Color_B[1] = 0x00;
			Color_R[2] = 0x00;		Color_G[2] = 0x00;		Color_B[2] = 0x00;
			Color_R[3] = 0x00;		Color_G[3] = 0x00;		Color_B[3] = 0x00;
			Color_R[4] = 0x00;		Color_G[4] = 0x00;		Color_B[4] = 0x00;
			Color_R[5] = 0x00;		Color_G[5] = 0x00;		Color_B[5] = 0x00;
			Color_R[6] = 0x00;		Color_G[6] = 0x00;		Color_B[6] = 0x00;
			Color_R[7] = 0x00;		Color_G[7] = 0x00;		Color_B[7] = 0x00;
			Color_R[8] = 0x00;		Color_G[8] = 0x00;		Color_B[8] = 0x00;
			Color_R[9] = 0x00;		Color_G[9] = 0x00;		Color_B[9] = 0x00;
			Color_R[10] = 0x00;		Color_G[10] = 0x00;		Color_B[10] = 0x00;

			Color_R[11] = 0x00;		Color_G[11] = 0x00;		Color_B[11] = 0x00;
			Color_R[12] = 0x00;		Color_G[12] = 0x00;		Color_B[12] = 0x00;
			Color_R[13] = 0x00;		Color_G[13] = 0x00;		Color_B[13] = 0x00;
			Color_R[14] = 0x00;		Color_G[14] = 0x00;		Color_B[14] = 0x00;
			Color_R[15] = 0x00;		Color_G[15] = 0x00;		Color_B[15] = 0x00;
			Color_R[16] = 0x00;		Color_G[16] = 0x00;		Color_B[16] = 0x00;
			Color_R[17] = 0x00;		Color_G[17] = 0x00;		Color_B[17] = 0x00;
			Color_R[18] = 0x00;		Color_G[18] = 0x00;		Color_B[18] = 0x00;
			Color_R[19] = 0x00;		Color_G[19] = 0x00;		Color_B[19] = 0x00;
			Color_R[20] = 0x00;		Color_G[20] = 0x00;		Color_B[20] = 0x00;

/*



			//1ڂ̐ݒlɈړ
			tmp_color_r = Color_R[20];
			tmp_color_g = Color_G[20];
			tmp_color_b = Color_B[20];
			for(tmp1 = 11;tmp1 < 21;tmp1++){
				Color_R[tmp1+1] = Color_R[tmp1];
				Color_G[tmp1+1] = Color_G[tmp1];
				Color_B[tmp1+1] = Color_B[tmp1];
			}
			Color_R[11] = tmp_color_r;
			Color_G[11] = tmp_color_g;
			Color_B[11] = tmp_color_b;

*/

			//J[Zbg
			ws2822_set_color();	

			delay_ms(ws2822_step_weight);//

		}else if(mode == 3){
			//EBJ[[h

			if(step == 0){	}

			//1ڂ̐ݒlɈړ
			tmp_color_r = Color_R[20];
			tmp_color_g = Color_G[20];
			tmp_color_b = Color_B[20];
			for(tmp1 = 20;tmp1 > 11;tmp1--){
				Color_R[tmp1] = Color_R[tmp1-1];
				Color_G[tmp1] = Color_G[tmp1-1];
				Color_B[tmp1] = Color_B[tmp1-1];
			}
			Color_R[11] = tmp_color_r;
			Color_G[11] = tmp_color_g;
			Color_B[11] = tmp_color_b;


			//J[Zbg
			ws2822_set_color();	

			delay_ms(ws2822_step_weight);//
		}else if(mode == 4){
			//EEBJ[[h

			//1ڂ̐ݒlɈړ
			tmp_color_r = Color_R[1];
			tmp_color_g = Color_G[1];
			tmp_color_b = Color_B[1];
			for(tmp1 = 1;tmp1 < 10;tmp1++){
				Color_R[tmp1] = Color_R[tmp1+1];
				Color_G[tmp1] = Color_G[tmp1+1];
				Color_B[tmp1] = Color_B[tmp1+1];
			}
			Color_R[10] = tmp_color_r;
			Color_G[10] = tmp_color_g;
			Color_B[10] = tmp_color_b;


			//J[Zbg
			ws2822_set_color();	

			delay_ms(ws2822_step_weight);//
		}else if(mode == 5){
			//nU[h[h

			//1ڂ̐ݒlɈړ
			tmp_color_r = Color_R[1];
			tmp_color_g = Color_G[1];
			tmp_color_b = Color_B[1];
			for(tmp1 = 1;tmp1 < 10;tmp1++){
				Color_R[tmp1] = Color_R[tmp1+1];
				Color_G[tmp1] = Color_G[tmp1+1];
				Color_B[tmp1] = Color_B[tmp1+1];
			}
			Color_R[10] = tmp_color_r;
			Color_G[10] = tmp_color_g;
			Color_B[10] = tmp_color_b;

			//1ڂ̐ݒlɈړ
			tmp_color_r = Color_R[20];
			tmp_color_g = Color_G[20];
			tmp_color_b = Color_B[20];
			for(tmp1 = 20;tmp1 > 11;tmp1--){
				Color_R[tmp1] = Color_R[tmp1-1];
				Color_G[tmp1] = Color_G[tmp1-1];
				Color_B[tmp1] = Color_B[tmp1-1];
			}
			Color_R[11] = tmp_color_r;
			Color_G[11] = tmp_color_g;
			Color_B[11] = tmp_color_b;

			//J[Zbg
			ws2822_set_color();	

			delay_ms(ws2822_step_weight);//
		}else if(mode == 6){

			//J[Zbg
			ws2822_set_color();	

			delay_ms(ws2822_step_weight);//
		}


		//tbJ[
		flicker_hi = !flicker_hi;

		//o̓|[g̏
		output_process();
	}
}

//̓|[g擾
void input_process(){

	port1_ra0 = input(PIN_A0);
	if(port1_ra0 != port1_ra0_re && port1_ra0 == 1){	btn_0 = 1;	}
	port1_ra0_re = port1_ra0;
	
	port1_ra1 = input(PIN_A1);
	if(port1_ra1 != port1_ra1_re && port1_ra1 == 1){	btn_1 = 1;	}
	port1_ra1_re = port1_ra1;

	port1_ra2 = input(PIN_A2);
	if(port1_ra2 != port1_ra2_re && port1_ra2 == 1){	btn_2 = 1;	}
	port1_ra2_re = port1_ra2;

	port1_ra3 = input(PIN_A3);
	if(port1_ra3 != port1_ra3_re && port1_ra3 == 1){	btn_3 = 1;	}
	port1_ra3_re = port1_ra3;
}

//o̓|[g
void output_process(){

	//LED\(8)
	//LEDo͔͂]邱
	output_bit(PIN_B0,!bit_test(ws2822_step_weight,0));
	output_bit(PIN_B1,!bit_test(ws2822_step_weight,1));
	output_bit(PIN_B2,!bit_test(ws2822_step_weight,2));
	output_bit(PIN_B3,!bit_test(ws2822_step_weight,3));
	output_bit(PIN_B4,!bit_test(ws2822_step_weight,4));
	output_bit(PIN_B5,!bit_test(ws2822_step_weight,5));
	output_bit(PIN_C0,!bit_test(ws2822_step_weight,6));
	output_bit(PIN_C1,!bit_test(ws2822_step_weight,7));

	//LED\(5)
	//LEDo͔͂]邱
	if(mode == 1){
		output_bit(PIN_C2,!1);	
	}else{
		output_bit(PIN_C2,!0);
	}
	output_bit(PIN_C5,!flicker_hi);
	output_bit(PIN_G0,flicker_hi);
	output_bit(PIN_G3,!flicker_hi);
	output_bit(PIN_G4,flicker_hi);

	//PORT1
	//output_bit(PIN_A0,!flicker_hi);
	//output_bit(PIN_A1,!flicker_hi);
	//output_bit(PIN_A2,!flicker_hi);
	//output_bit(PIN_A3,!flicker_hi);
	output_bit(PIN_A4,!flicker_hi);
	output_bit(PIN_A5,!flicker_hi);
	output_bit(PIN_A6,!flicker_hi);
	output_bit(PIN_A7,!flicker_hi);

	if(flicker_hi==0){
		//PORT1
		output_d(0xff);
		//PORT2
		output_e(0xff);
		output_f(0xff);
	}else{
		//PORT1
		output_d(0x00);
		//PORT2
		output_e(0x00);
		output_f(0x00);
	}

}

//VA|[g̃R}h
void serial_process1(){
	int tmp1 = 0;
	char *command;
	int *param1;
	//char *param1;
	int rdata = 0;

	while(kbhit(c1)){  // }CR̎Mobt@̃f[^SĎM
		get_command_c1[get_command_value_c1] = fgetc(c1);//Mf[^o
		fprintf(c1,"%c",get_command_c1[get_command_value_c1]);
		get_command_value_c1++;//CfbNX{P
	}

	if(get_command_c1[get_command_value_c1-1]==0xd){
		//R}hƃp[^𕪊
		command = strtok(get_command_c1,punctuate);
		param1 = atoi(strtok(null,punctuate));
		//param1 = strtok(null,punctuate);

		fprintf(c1,"\r\n");

		strcpy(compare_command_c1,"?\r");
		if(strcmp(command,compare_command_c1)==0){
			//wv
			fprintf(c1,"ZT-****-SOFT Ver.0.90\r\n");
			fprintf(c1,"analog_value=%ldmV\r\n",analog_value);
			fprintf(c1,"port1_ra=%d,%d\r\n",port1_ra0,port1_ra1);
			fprintf(c1,"mode=%u\r\n",mode);
			
		}

		strcpy(compare_command_c1,"weight\r");
		if(strcmp(command,compare_command_c1)==0){
			fprintf(c1,"weight %uusec set ok.\r\n",ws2822_step_weight);		
		}

		strcpy(compare_command_c1,"weight");
		if(strcmp(command,compare_command_c1)==0){
			//EFCgݒ
			
			ws2822_step_weight = param1;
			fprintf(c1,"weight %uusec set ok.\r\n",ws2822_step_weight);
		}

		//SăNA
		for(tmp1=0;tmp1<80;++tmp1){
			get_command_c1[tmp1] = 0x0;
		}
		get_command_value_c1 = 0;

		//QƗp̃R}hNA
		for(tmp1=0;tmp1<10;++tmp1){
			compare_command_c1[tmp1] = 0x0;
		}
	}
}
